package nccloud.zjnytwo_cd.zjnytwo_cd.bankaccountshvo.action;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.zjnytwo_cd.bankaccounts.BankaccountsBVO;
import nc.vo.zjnytwo_cd.bankaccounts.BankaccountsBillVO;
import nc.vo.zjnytwo_cd.bankaccounts.BankaccountsHVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.core.io.WebFile;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.container.SessionContext;
import nccloud.pubitf.riart.pflow.CloudPFlowContext;
import nccloud.pubitf.riart.pflow.ICloudScriptPFlowService;
import nccloud.vo.zjnytwo_cd.zjnytwo_cd.BankaccountsHVOConst;
import nccloud.zjnytwo_cd.zjnytwo_cd.bankaccountshvo.zjnytwo_cd.util.CommonUtil;
import nccloud.zjnytwo_cd.zjnytwo_cd.tool.Excel;

/**
 * 银行账户填报单导入
 * @author LP
 *
 */
public class BankaccountsHVOImportAction implements ICommonAction {

	public String group;
	public String org;
	public String org_v;
	public int month;
	public String year;
	
	public BaseDAO dao;
	public IMDPersistenceQueryService qryService;
	
	@Override
	public Object doAction(IRequest paramIRequest) {
		
		WebFile[] readFiles = paramIRequest.readFiles();
		
		WebFile file = readFiles[0];
		
		try {
			
			dao = new BaseDAO();
			qryService = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
			
			JSONArray jsonArray = Excel.readXLSX(file);//解析Excel
			
			BankaccountsBillVO bankaccountsBillVO = setBankaccountsBillVO(jsonArray);
			
			saveBankaccountsBillVO(bankaccountsBillVO);

		} catch (Exception e) {
			Logger.error(e);
		    ExceptionUtils.wrapException(e);
		}
		
		return null;
	}
	
	/*
	 * 保存VO
	 */
	private BankaccountsBillVO saveBankaccountsBillVO(BankaccountsBillVO bankaccountsBillVO) throws BusinessException {
		
		uniform(bankaccountsBillVO);
		
		judgment(bankaccountsBillVO);
		
		BankaccountsBillVO bVo = showBankaccountsBillVOs();
		
		if (bVo!=null) {
			deleteVO(bVo);//删除VO
		}
		BankaccountsBillVO svo = saveVO(bankaccountsBillVO);
		
		return svo;
	}
	
	/*
	 *  表头表体单位一致校验
	 */
	public void uniform(BankaccountsBillVO vo) throws DAOException {
		
		  String headorg = vo.getParentVO().getPk_org();
		  String bodyorg = "";
		  
		  BankaccountsBVO[] bvos = (BankaccountsBVO[])vo.getChildrenVO();
		  
		  for (BankaccountsBVO bankaccountsBVO : bvos) {
			  
			  bodyorg = bankaccountsBVO.getUnit();
			
			  if (!bodyorg.equals(headorg)) {
				throw new DAOException("表头一级组织与表体一级单位必须一致！");
			  }
			  
		  }
		  
	  }
	
	/*
	   * 校验单位映射是否正确
	   */
	  public void judgment(BankaccountsBillVO bankaccountsBillVO) throws DAOException {
		
		String unit = "";
		String accountunit = "";
		String unitfather = "";
		String accountunitfather = "";
		
		BankaccountsBVO[] childrenVO = (BankaccountsBVO[]) bankaccountsBillVO.getChildrenVO();
		
		String father = SqlQuery("pk_financeorg", "org_financeorg", "code", "10", "一级财务组织编码10");
		
		String org = bankaccountsBillVO.getParentVO().getPk_org();
		String orgfather = SqlQuery("pk_fatherorg", "org_orgs", "pk_org", org, "组织父单位");
		String orgname = SqlQuery("name", "org_orgs", "pk_org", org, "一级组织");
		
		if (orgfather!=null && !orgfather.equals(father)) {
			throw new DAOException("一级组织'"+orgname+"'不是一级组织，请检查数据的合法性！");
		}else if (orgname.equals("全局")) {
			throw new DAOException("一级组织不能为空，如是'全局'请修改！");
		}
			
		for (int i = 0; i < childrenVO.length; i++) {
				
			BankaccountsBVO bvo = childrenVO[i];
				
			unit = bvo.getUnit();
			accountunit = bvo.getAccountunit();
			
			String unitName = SqlQuery("name", "org_financeorg", "pk_financeorg", unit, "一级单位");
			String accountunitName = SqlQuery("name", "org_financeorg", "pk_financeorg", accountunit, "开户单位");
			
			unitfather = SqlQuery("pk_fatherorg", "org_orgs", "pk_org", unit, "一级父单位");
			
			if (unitfather!=null && !unitfather.equals(father)) {
				throw new DAOException("一级单位'"+unitName+"'不是一级组织，请检查数据的合法性！");
			}else if (accountunit.equals(father)&&!unit.equals(accountunit)) {
				throw new DAOException("开户单位'"+accountunitName+"'不是一级单位'"+unitName+"'的子公司，不能保存！");
			}else if(unit.equals(accountunit)) {
				return;
			}
			
			
			accountunitfather = SqlQuery("pk_fatherorg", "org_orgs", "pk_org", accountunit, "开户父单位");
			
			for (int k = 0; k < 10; k++) {
				
				if (accountunitfather.equals(unit)) {
					break;
				}else if (accountunitfather.equals(father)) {
					throw new DAOException("开户单位'"+accountunitName+"'不是一级单位'"+unitName+"'的子公司，不能保存！");
				}else{
					accountunitfather=SqlQuery("pk_fatherorg", "org_orgs", "pk_org", accountunitfather, "开户父单位");
				}
				
				
			}
		}
	  }
	
	/*
	 * 查找VO
	 */
	private BankaccountsBillVO showBankaccountsBillVOs() throws MetaDataException {
		
		String sql = "month = '"+String.valueOf(month)+"' and pk_org = '"+org+"' and dr = '0' and def1 = '"+year+"'";
		
		BankaccountsBillVO oldBankaccountsBillVO = getVO(sql);
		
		if (oldBankaccountsBillVO==null) {
			return null;
		}
		
		return oldBankaccountsBillVO;
	}
	
	/*
	 * 组合BankaccountsBillVO
	 */
	private BankaccountsBillVO setBankaccountsBillVO(JSONArray jsonArray) throws Exception {
		
		BankaccountsBillVO bankaccountsBillVO = new BankaccountsBillVO();
		
		JSONArray headArray = jsonArray.getJSONArray(0);//表头
		JSONArray bodylArray = jsonArray.getJSONArray(1);//表体
		
		BankaccountsHVO headHvo = sethead(headArray);
		BankaccountsBVO[] bodyBvo = setbody(bodylArray);
		
		bankaccountsBillVO.setParentVO(headHvo);
		bankaccountsBillVO.setChildrenVO(bodyBvo);
		
		return bankaccountsBillVO;
	}
	
	/*
	 * 导入表头
	 */
	@SuppressWarnings("static-access")
	private BankaccountsHVO sethead(JSONArray headArray) throws Exception {
		
		BankaccountsHVO bankaccountsHVO = new BankaccountsHVO();
		JSONObject headObject = headArray.getJSONObject(0);
		
		String enablestate = headObject.getString("启用");
		
		if (headArray.size()>1) {
			throw new Exception("表头不允许有多列！请检查数据的合法性或Excel表格是否符合规范！");
		}
		
		if (enablestate==null) {
			throw new Exception("启用为必填项，请检查！");
		}
		
		if (headObject.getString("组织")==null) {
			throw new Exception("组织为必填项，请检查！");
		}
		
		if(enablestate.equals("Y")) {
			bankaccountsHVO.setEnablestate(2);
		}else if(enablestate.equals("N")) {
			bankaccountsHVO.setEnablestate(3);
		}else {
			throw new Exception("启用只允许填写'N'和'Y'，请检查！");
		}
		
		group = SqlQuery("pk_group", "org_group", "name", headObject.getString("集团"),"集团");
		org = SqlQuery("pk_financeorg", "org_financeorg", "name", headObject.getString("组织"),"组织");
		org_v = SqlQuery("pk_vid", "org_financeorg_v", "name", headObject.getString("组织"),"组织");;
		
		bankaccountsHVO.setPk_group(group);
		bankaccountsHVO.setPk_org(org);
		bankaccountsHVO.setPk_org_v(org_v);
		
		
//		Calendar calendar = Calendar.getInstance();
//		month = calendar.get(Calendar.MONTH) + 1; 
		month = Integer.valueOf(headObject.getString("月份"));
		bankaccountsHVO.setMonth(month);//月份
		
		if (month<1 || month>12) {
			throw new BusinessException("月份只允许填写1~12的数字！");
		}
		
		Date date = new Date();
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd"); 
		SimpleDateFormat formatter2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); 
		String Inputdate = formatter.format(date);
		String Dbilldate = formatter2.format(date);
		bankaccountsHVO.setInputdate(new UFDate(Inputdate));//导入日期
		bankaccountsHVO.setDbilldate(new UFDateTime(Dbilldate));//单据日期
		
		String cuserid = SessionContext.getInstance().getClientInfo().getUserid();
		
		bankaccountsHVO.setInputman(cuserid);
		bankaccountsHVO.setCode(headObject.getString("编码"));
		bankaccountsHVO.setName(headObject.getString("名称"));
		bankaccountsHVO.setVnote(headObject.getString("备注"));
		
		if(headObject.getString("年份").equals("")) {
			SimpleDateFormat SimpleDate = new SimpleDateFormat("yyyy");
	        year = SimpleDate.format(date);
			bankaccountsHVO.setDef1(year);
		}else {
			if (this.isNumber(headObject.getString("年份"))) {
				year = headObject.getString("年份");
				bankaccountsHVO.setDef1(year);
			}
		}
		
		return bankaccountsHVO;
		
	}
	
	/**
	 * 判断年份
	 * @param str
	 * @return
	 * @throws Exception
	 */
	private static boolean isNumber(String str) throws Exception{
        String reg = "^[0-9]+(.[0-9]+)?$";
        if(str.matches(reg)) {
        	if (str.length()>4 || str.length()<4) {
				throw new Exception("请输入正确的年份！");
			}else {
				return true;
			}
        }else {
        	throw new Exception("年份只允许填入数字，请检查！");
		}
    }
	
	/*
	 * 导入表体
	 */
	private BankaccountsBVO[] setbody(JSONArray bodylArray) throws DAOException {
		
		BankaccountsBVO[] bvos = new BankaccountsBVO[bodylArray.size()];
		
		for(int i = 0 ; i < bodylArray.size() ; i++ ) {
			
			JSONObject bodyobject = bodylArray.getJSONObject(i);
			
			BankaccountsBVO bankaccountsBVO = new BankaccountsBVO();
			
			bankaccountsBVO.setPk_group(group);
			bankaccountsBVO.setPk_org(org);
			bankaccountsBVO.setPk_org_v(org_v);
			bankaccountsBVO.setCrowno(bodyobject.getString("行号"));
			bankaccountsBVO.setUnit(SqlQuery("pk_financeorg", "org_financeorg", "name", bodyobject.getString("一级单位"),"一级单位"));
			bankaccountsBVO.setAccountunit(SqlQuery("pk_financeorg", "org_financeorg_v", "name", bodyobject.getString("开户单位"),"开户单位"));
			bankaccountsBVO.setAccountbank(bodyobject.getString("开户银行"));
			bankaccountsBVO.setAccount(bodyobject.getString("账号"));
			bankaccountsBVO.setCurrency(bodyobject.getString("币种"));
			bankaccountsBVO.setAccounttype(bodyobject.getString("账户类型"));
			bankaccountsBVO.setAccountdate(new UFDate(bodyobject.getString("开户日期")));
			bankaccountsBVO.setBankoperator(bodyobject.getString("网银操作员"));
			bankaccountsBVO.setBankreviewer(bodyobject.getString("网银复核员"));
			bankaccountsBVO.setBankadmin(bodyobject.getString("网银管理员"));
			bankaccountsBVO.setIssigned(bodyobject.getString("是否签订U盾证书"));
			bankaccountsBVO.setU_code(bodyobject.getString("U盾编码"));
			bankaccountsBVO.setBankstate(bodyobject.getString("网银开通状态"));
			bankaccountsBVO.setBankcheck(bodyobject.getString("网银登记单"));
			bankaccountsBVO.setVbnote(bodyobject.getString("行备注"));
			
			bvos[i] = bankaccountsBVO;
		}
		
		return bvos;
	}
	
	/*
	 * VO查询方法
	 */
	@SuppressWarnings("unchecked")
	private BankaccountsBillVO getVO(String sql) throws MetaDataException {
		
		ArrayList<BankaccountsBillVO> AggVOs = (ArrayList<BankaccountsBillVO>) qryService.queryBillOfVOByCond(BankaccountsBillVO.class,sql,true,false);
		
		if (AggVOs.size()==0) {
			return null;
		}else {
			return AggVOs.get(0);
		}
	}
	
	/*
	 * SQL查询方法
	 */
	private String SqlQuery(String out,String table,String lock,String key,String remark) throws DAOException {
		
		if (key==null || key.equals("")) {
			return null;
		}
		
		String sql = "select "+out+" from "+table+" where "+lock+" = '"+key+"' and dr = '0'";
		
		Object object = dao.executeQuery(sql, new ColumnProcessor());
		
		if (remark.equals("一级父单位") && object == null) {
			return null;
		}else if (remark.equals("组织父单位") && object == null) {
			return null;
		}else if (object == null) {
			throw new DAOException("根据"+remark+"值"+key+"在数据库中未查到相应的数据，请检查！");
		}
		
		return object.toString();
	}
	
	/*
	 * 删除脚本
	 */
	@SuppressWarnings({ "unchecked", "unused" })
	private BankaccountsBillVO deleteVO(BankaccountsBillVO... aggVOs)
		      throws BusinessException {

		    String actionCode = BankaccountsHVOConst.CONST_ACTION_DELETE;
		    String billType = BankaccountsHVOConst.CONST_BILLTYPE_COST;

		    CloudPFlowContext context = new CloudPFlowContext();
		    context.setActionName(actionCode);
		    context.setBillType(billType);
		    context.setBillVos(aggVOs);
		    Logger.debug("开始调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]...");

		    ICloudScriptPFlowService service =
		        CommonUtil.getCloudScriptPFlowService();

		    Object[] result = service.exeScriptPFlow(context);

		    Logger.debug("调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]结束");

		    String wheresql =
		        "pk_bankaccount" + "='"
		            + ((BankaccountsBillVO) result[0]).getPrimaryKey() + "'";
		    Collection<BankaccountsBillVO> bills =
		        CommonUtil.getMDPersistenceQueryService().queryBillOfVOByCond(
		            BankaccountsBillVO.class, wheresql, true, false);
//		    return bills.toArray(new BankaccountsBillVO[0])[0];
		    return null;
	}
	
	/*
	 * 保存脚本
	 */
	@SuppressWarnings("unchecked")
	private BankaccountsBillVO saveVO(BankaccountsBillVO... aggVOs)
		      throws BusinessException {

		    String actionCode = BankaccountsHVOConst.CONST_ACTION_SAVEBASE;
		    String billType = BankaccountsHVOConst.CONST_BILLTYPE_COST;

		    CloudPFlowContext context = new CloudPFlowContext();
		    context.setActionName(actionCode);
		    context.setBillType(billType);
		    context.setBillVos(aggVOs);
		    Logger.debug("开始调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]...");

		    ICloudScriptPFlowService service =
		        CommonUtil.getCloudScriptPFlowService();

		    Object[] result = service.exeScriptPFlow(context);

		    Logger.debug("调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]结束");

		    String wheresql =
		        "pk_bankaccount" + "='"
		            + ((BankaccountsBillVO) result[0]).getPrimaryKey() + "'";
		    Collection<BankaccountsBillVO> bills =
		        CommonUtil.getMDPersistenceQueryService().queryBillOfVOByCond(
		            BankaccountsBillVO.class, wheresql, true, false);
		    return bills.toArray(new BankaccountsBillVO[0])[0];
	}

}
