
package nc.bs.pub.action;

import nc.bs.framework.common.NCLocator;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.plugin.bpplugin.LettercreditHVOPluginPoint;
import nc.bs.pubapp.pf.action.AbstractPfAction;
import nc.bs.pubapp.pub.rule.UnapproveStatusCheckRule;
import nc.impl.pubapp.pattern.rule.processer.CompareAroundProcesser;
import nccloud.itf.zjnytwo_cd.zjnytwo_cd.ILettercredithvoMaintain;
import nc.vo.zjnytwo_cd.lettercredit.LettercreditBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class N_99H2_UNAPPROVE extends AbstractPfAction<LettercreditBillVO> {

        @Override
        protected CompareAroundProcesser<LettercreditBillVO> getCompareAroundProcesserWithRules(
                        Object userObj) {
                CompareAroundProcesser<LettercreditBillVO> processor = new CompareAroundProcesser<LettercreditBillVO>(
                                LettercreditHVOPluginPoint.UNAPPROVE);
                // TODO 在此处添加前后规则
                processor.addBeforeRule(new UnapproveStatusCheckRule());

                return processor;
        }

        @Override
        protected LettercreditBillVO[] processBP(Object userObj,
                        LettercreditBillVO[] clientFullVOs, LettercreditBillVO[] originBills) {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                LettercreditBillVO[] bills = null;
                try {
                        ILettercredithvoMaintain operator = NCLocator.getInstance()
                                        .lookup(ILettercredithvoMaintain.class);
                        bills = operator.unapprove(clientFullVOs, originBills);
                } catch (BusinessException e) {
                        ExceptionUtils.wrappBusinessException(e.getMessage());
                }
                return bills;
        }

}
