
package nc.bs.pub.action;

import nc.bs.framework.common.NCLocator;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.plugin.bpplugin.BankcreditHVOPluginPoint;
import nc.bs.pubapp.pf.action.AbstractPfAction;
import nc.bs.pubapp.pub.rule.UnapproveStatusCheckRule;
import nc.impl.pubapp.pattern.rule.processer.CompareAroundProcesser;
import nccloud.itf.zjnytwo_cd.zjnytwo_cd.IBankcredithvoMaintain;
import nc.vo.zjnytwo_cd.bankcredit.BankcreditBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class N_99H3_UNAPPROVE extends AbstractPfAction<BankcreditBillVO> {

        @Override
        protected CompareAroundProcesser<BankcreditBillVO> getCompareAroundProcesserWithRules(
                        Object userObj) {
                CompareAroundProcesser<BankcreditBillVO> processor = new CompareAroundProcesser<BankcreditBillVO>(
                                BankcreditHVOPluginPoint.UNAPPROVE);
                // TODO 在此处添加前后规则
                processor.addBeforeRule(new UnapproveStatusCheckRule());

                return processor;
        }

        @Override
        protected BankcreditBillVO[] processBP(Object userObj,
                        BankcreditBillVO[] clientFullVOs, BankcreditBillVO[] originBills) {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                BankcreditBillVO[] bills = null;
                try {
                        IBankcredithvoMaintain operator = NCLocator.getInstance()
                                        .lookup(IBankcredithvoMaintain.class);
                        bills = operator.unapprove(clientFullVOs, originBills);
                } catch (BusinessException e) {
                        ExceptionUtils.wrappBusinessException(e.getMessage());
                }
                return bills;
        }

}
