
package nc.bs.pub.action;

import nc.bs.framework.common.NCLocator;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.plugin.bpplugin.BankloanHVOPluginPoint;
import nc.bs.pubapp.pf.action.AbstractPfAction;
import nc.bs.pubapp.pub.rule.UnapproveStatusCheckRule;
import nc.impl.pubapp.pattern.rule.processer.CompareAroundProcesser;
import nccloud.itf.zjnytwo_cd.zjnytwo_cd.IBankloanhvoMaintain;
import nc.vo.zjnytwo_cd.bankloan.BankloanBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class N_99H4_UNAPPROVE extends AbstractPfAction<BankloanBillVO> {

        @Override
        protected CompareAroundProcesser<BankloanBillVO> getCompareAroundProcesserWithRules(
                        Object userObj) {
                CompareAroundProcesser<BankloanBillVO> processor = new CompareAroundProcesser<BankloanBillVO>(
                                BankloanHVOPluginPoint.UNAPPROVE);
                // TODO 在此处添加前后规则
                processor.addBeforeRule(new UnapproveStatusCheckRule());

                return processor;
        }

        @Override
        protected BankloanBillVO[] processBP(Object userObj,
                        BankloanBillVO[] clientFullVOs, BankloanBillVO[] originBills) {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                BankloanBillVO[] bills = null;
                try {
                        IBankloanhvoMaintain operator = NCLocator.getInstance()
                                        .lookup(IBankloanhvoMaintain.class);
                        bills = operator.unapprove(clientFullVOs, originBills);
                } catch (BusinessException e) {
                        ExceptionUtils.wrappBusinessException(e.getMessage());
                }
                return bills;
        }

}
