
package nccloud.impl.pub.ace;

import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankaccountsHVOApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankaccountsHVODeleteBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankaccountsHVOInsertBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankaccountsHVOSendApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankaccountsHVOUnApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankaccountsHVOUnSendApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankaccountsHVOUpdateBP;
import nc.impl.pubapp.pattern.data.bill.BillLazyQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillTransferTool;
import nc.ui.querytemplate.querytree.IQueryScheme;
import nc.vo.zjnytwo_cd.bankaccounts.BankaccountsBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public abstract class AceAggbusiBankaccountsHVOPubServiceImpl {
        // 新增
        public BankaccountsBillVO[] pubinsertBills(BankaccountsBillVO[] clientFullVOs,
                        BankaccountsBillVO[] originBills) throws BusinessException {
                try {
                        synchronized (clientFullVOs) {
                                // 数据库中数据和前台传递过来的差异VO合并后的结果
                                BillTransferTool<BankaccountsBillVO> transferTool = new BillTransferTool<BankaccountsBillVO>(
                                                clientFullVOs);
                                // 调用BP
                                AceBankaccountsHVOInsertBP action = new AceBankaccountsHVOInsertBP();
                                BankaccountsBillVO[] retvos = action.insert(clientFullVOs);
                                // 构造返回数据
        //                      return transferTool.getBillForToClient(retvos);
                                return retvos;
                        }
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        // 删除
        public void pubdeleteBills(BankaccountsBillVO[] clientFullVOs,
                        BankaccountsBillVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                    BillTransferTool<BankaccountsBillVO> transferTool =
                        new BillTransferTool<BankaccountsBillVO>(clientFullVOs);
                        // 调用BP
                        new AceBankaccountsHVODeleteBP().delete(clientFullVOs);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
        }

        // 修改
        public BankaccountsBillVO[] pubupdateBills(BankaccountsBillVO[] clientFullVOs,
                        BankaccountsBillVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                        BillTransferTool<BankaccountsBillVO> transferTool = new BillTransferTool<BankaccountsBillVO>(
                                        clientFullVOs);
                        AceBankaccountsHVOUpdateBP bp = new AceBankaccountsHVOUpdateBP();
                        BankaccountsBillVO[] retvos = bp.update(clientFullVOs, originBills);
                        // 构造返回数据
                        return transferTool.getBillForToClient(retvos);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        public BankaccountsBillVO[] pubquerybills(IQueryScheme queryScheme)
                        throws BusinessException {
                BankaccountsBillVO[] bills = null;
                try {
                        this.preQuery(queryScheme);
                        BillLazyQuery<BankaccountsBillVO> query = new BillLazyQuery<BankaccountsBillVO>(
                                        BankaccountsBillVO.class);
                        bills = query.query(queryScheme, null);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return bills;
        }

        /**
         * 由子类实现，查询之前对queryScheme进行加工，加入自己的逻辑
         * 
         * @param queryScheme
         */
        protected void preQuery(IQueryScheme queryScheme) {
                // 查询之前对queryScheme进行加工，加入自己的逻辑
        }

        // 提交
        public BankaccountsBillVO[] pubsendapprovebills(
                        BankaccountsBillVO[] clientFullVOs, BankaccountsBillVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
        BillTransferTool<BankaccountsBillVO> transferTool =
                new BillTransferTool<BankaccountsBillVO>(clientFullVOs);
                AceBankaccountsHVOSendApproveBP bp = new AceBankaccountsHVOSendApproveBP();
                BankaccountsBillVO[] retvos = bp.sendApprove(clientFullVOs, originBills);
                return retvos;
        }

        // 收回
        public BankaccountsBillVO[] pubunsendapprovebills(
                        BankaccountsBillVO[] clientFullVOs, BankaccountsBillVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
                BillTransferTool<BankaccountsBillVO> transferTool =
                        new BillTransferTool<BankaccountsBillVO>(clientFullVOs);
                AceBankaccountsHVOUnSendApproveBP bp = new AceBankaccountsHVOUnSendApproveBP();
                BankaccountsBillVO[] retvos = bp.unSend(clientFullVOs, originBills);
                return retvos;
        };

        // 审批
        public BankaccountsBillVO[] pubapprovebills(BankaccountsBillVO[] clientFullVOs,
                        BankaccountsBillVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<BankaccountsBillVO> transferTool =
                        new BillTransferTool<BankaccountsBillVO>(clientFullVOs);
                AceBankaccountsHVOApproveBP bp = new AceBankaccountsHVOApproveBP();
                BankaccountsBillVO[] retvos = bp.approve(clientFullVOs, originBills);
                return retvos;
        }

        // 弃审

        public BankaccountsBillVO[] pubunapprovebills(BankaccountsBillVO[] clientFullVOs,
                        BankaccountsBillVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<BankaccountsBillVO> transferTool =
                        new BillTransferTool<BankaccountsBillVO>(clientFullVOs);
                AceBankaccountsHVOUnApproveBP bp = new AceBankaccountsHVOUnApproveBP();
                BankaccountsBillVO[] retvos = bp.unApprove(clientFullVOs, originBills);
                return retvos;
        }

}