
package nccloud.impl.pub.ace;

import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankcreditHVOApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankcreditHVODeleteBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankcreditHVOInsertBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankcreditHVOSendApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankcreditHVOUnApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankcreditHVOUnSendApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankcreditHVOUpdateBP;
import nc.impl.pubapp.pattern.data.bill.BillLazyQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillTransferTool;
import nc.ui.querytemplate.querytree.IQueryScheme;
import nc.vo.zjnytwo_cd.bankcredit.BankcreditBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public abstract class AceAggbusiBankcreditHVOPubServiceImpl {
        // 新增
        public BankcreditBillVO[] pubinsertBills(BankcreditBillVO[] clientFullVOs,
                        BankcreditBillVO[] originBills) throws BusinessException {
                try {
                        synchronized (clientFullVOs) {
                                // 数据库中数据和前台传递过来的差异VO合并后的结果
                                BillTransferTool<BankcreditBillVO> transferTool = new BillTransferTool<BankcreditBillVO>(
                                                clientFullVOs);
                                // 调用BP
                                AceBankcreditHVOInsertBP action = new AceBankcreditHVOInsertBP();
                                BankcreditBillVO[] retvos = action.insert(clientFullVOs);
                                // 构造返回数据
        //                      return transferTool.getBillForToClient(retvos);
                                return retvos;
                        }
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        // 删除
        public void pubdeleteBills(BankcreditBillVO[] clientFullVOs,
                        BankcreditBillVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                    BillTransferTool<BankcreditBillVO> transferTool =
                        new BillTransferTool<BankcreditBillVO>(clientFullVOs);
                        // 调用BP
                        new AceBankcreditHVODeleteBP().delete(clientFullVOs);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
        }

        // 修改
        public BankcreditBillVO[] pubupdateBills(BankcreditBillVO[] clientFullVOs,
                        BankcreditBillVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                        BillTransferTool<BankcreditBillVO> transferTool = new BillTransferTool<BankcreditBillVO>(
                                        clientFullVOs);
                        AceBankcreditHVOUpdateBP bp = new AceBankcreditHVOUpdateBP();
                        BankcreditBillVO[] retvos = bp.update(clientFullVOs, originBills);
                        // 构造返回数据
                        return transferTool.getBillForToClient(retvos);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        public BankcreditBillVO[] pubquerybills(IQueryScheme queryScheme)
                        throws BusinessException {
                BankcreditBillVO[] bills = null;
                try {
                        this.preQuery(queryScheme);
                        BillLazyQuery<BankcreditBillVO> query = new BillLazyQuery<BankcreditBillVO>(
                                        BankcreditBillVO.class);
                        bills = query.query(queryScheme, null);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return bills;
        }

        /**
         * 由子类实现，查询之前对queryScheme进行加工，加入自己的逻辑
         * 
         * @param queryScheme
         */
        protected void preQuery(IQueryScheme queryScheme) {
                // 查询之前对queryScheme进行加工，加入自己的逻辑
        }

        // 提交
        public BankcreditBillVO[] pubsendapprovebills(
                        BankcreditBillVO[] clientFullVOs, BankcreditBillVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
        BillTransferTool<BankcreditBillVO> transferTool =
                new BillTransferTool<BankcreditBillVO>(clientFullVOs);
                AceBankcreditHVOSendApproveBP bp = new AceBankcreditHVOSendApproveBP();
                BankcreditBillVO[] retvos = bp.sendApprove(clientFullVOs, originBills);
                return retvos;
        }

        // 收回
        public BankcreditBillVO[] pubunsendapprovebills(
                        BankcreditBillVO[] clientFullVOs, BankcreditBillVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
                BillTransferTool<BankcreditBillVO> transferTool =
                        new BillTransferTool<BankcreditBillVO>(clientFullVOs);
                AceBankcreditHVOUnSendApproveBP bp = new AceBankcreditHVOUnSendApproveBP();
                BankcreditBillVO[] retvos = bp.unSend(clientFullVOs, originBills);
                return retvos;
        };

        // 审批
        public BankcreditBillVO[] pubapprovebills(BankcreditBillVO[] clientFullVOs,
                        BankcreditBillVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<BankcreditBillVO> transferTool =
                        new BillTransferTool<BankcreditBillVO>(clientFullVOs);
                AceBankcreditHVOApproveBP bp = new AceBankcreditHVOApproveBP();
                BankcreditBillVO[] retvos = bp.approve(clientFullVOs, originBills);
                return retvos;
        }

        // 弃审

        public BankcreditBillVO[] pubunapprovebills(BankcreditBillVO[] clientFullVOs,
                        BankcreditBillVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<BankcreditBillVO> transferTool =
                        new BillTransferTool<BankcreditBillVO>(clientFullVOs);
                AceBankcreditHVOUnApproveBP bp = new AceBankcreditHVOUnApproveBP();
                BankcreditBillVO[] retvos = bp.unApprove(clientFullVOs, originBills);
                return retvos;
        }

}