
package nccloud.impl.pub.ace;

import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceLettercreditHVOApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceLettercreditHVODeleteBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceLettercreditHVOInsertBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceLettercreditHVOSendApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceLettercreditHVOUnApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceLettercreditHVOUnSendApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceLettercreditHVOUpdateBP;
import nc.impl.pubapp.pattern.data.bill.BillLazyQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillTransferTool;
import nc.ui.querytemplate.querytree.IQueryScheme;
import nc.vo.zjnytwo_cd.lettercredit.LettercreditBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public abstract class AceAggbusiLettercreditHVOPubServiceImpl {
        // 新增
        public LettercreditBillVO[] pubinsertBills(LettercreditBillVO[] clientFullVOs,
                        LettercreditBillVO[] originBills) throws BusinessException {
                try {
                        synchronized (clientFullVOs) {
                                // 数据库中数据和前台传递过来的差异VO合并后的结果
                                BillTransferTool<LettercreditBillVO> transferTool = new BillTransferTool<LettercreditBillVO>(
                                                clientFullVOs);
                                // 调用BP
                                AceLettercreditHVOInsertBP action = new AceLettercreditHVOInsertBP();
                                LettercreditBillVO[] retvos = action.insert(clientFullVOs);
                                // 构造返回数据
        //                      return transferTool.getBillForToClient(retvos);
                                return retvos;
                        }
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        // 删除
        public void pubdeleteBills(LettercreditBillVO[] clientFullVOs,
                        LettercreditBillVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                    BillTransferTool<LettercreditBillVO> transferTool =
                        new BillTransferTool<LettercreditBillVO>(clientFullVOs);
                        // 调用BP
                        new AceLettercreditHVODeleteBP().delete(clientFullVOs);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
        }

        // 修改
        public LettercreditBillVO[] pubupdateBills(LettercreditBillVO[] clientFullVOs,
                        LettercreditBillVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                        BillTransferTool<LettercreditBillVO> transferTool = new BillTransferTool<LettercreditBillVO>(
                                        clientFullVOs);
                        AceLettercreditHVOUpdateBP bp = new AceLettercreditHVOUpdateBP();
                        LettercreditBillVO[] retvos = bp.update(clientFullVOs, originBills);
                        // 构造返回数据
                        return transferTool.getBillForToClient(retvos);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        public LettercreditBillVO[] pubquerybills(IQueryScheme queryScheme)
                        throws BusinessException {
                LettercreditBillVO[] bills = null;
                try {
                        this.preQuery(queryScheme);
                        BillLazyQuery<LettercreditBillVO> query = new BillLazyQuery<LettercreditBillVO>(
                                        LettercreditBillVO.class);
                        bills = query.query(queryScheme, null);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return bills;
        }

        /**
         * 由子类实现，查询之前对queryScheme进行加工，加入自己的逻辑
         * 
         * @param queryScheme
         */
        protected void preQuery(IQueryScheme queryScheme) {
                // 查询之前对queryScheme进行加工，加入自己的逻辑
        }

        // 提交
        public LettercreditBillVO[] pubsendapprovebills(
                        LettercreditBillVO[] clientFullVOs, LettercreditBillVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
        BillTransferTool<LettercreditBillVO> transferTool =
                new BillTransferTool<LettercreditBillVO>(clientFullVOs);
                AceLettercreditHVOSendApproveBP bp = new AceLettercreditHVOSendApproveBP();
                LettercreditBillVO[] retvos = bp.sendApprove(clientFullVOs, originBills);
                return retvos;
        }

        // 收回
        public LettercreditBillVO[] pubunsendapprovebills(
                        LettercreditBillVO[] clientFullVOs, LettercreditBillVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
                BillTransferTool<LettercreditBillVO> transferTool =
                        new BillTransferTool<LettercreditBillVO>(clientFullVOs);
                AceLettercreditHVOUnSendApproveBP bp = new AceLettercreditHVOUnSendApproveBP();
                LettercreditBillVO[] retvos = bp.unSend(clientFullVOs, originBills);
                return retvos;
        };

        // 审批
        public LettercreditBillVO[] pubapprovebills(LettercreditBillVO[] clientFullVOs,
                        LettercreditBillVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<LettercreditBillVO> transferTool =
                        new BillTransferTool<LettercreditBillVO>(clientFullVOs);
                AceLettercreditHVOApproveBP bp = new AceLettercreditHVOApproveBP();
                LettercreditBillVO[] retvos = bp.approve(clientFullVOs, originBills);
                return retvos;
        }

        // 弃审

        public LettercreditBillVO[] pubunapprovebills(LettercreditBillVO[] clientFullVOs,
                        LettercreditBillVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<LettercreditBillVO> transferTool =
                        new BillTransferTool<LettercreditBillVO>(clientFullVOs);
                AceLettercreditHVOUnApproveBP bp = new AceLettercreditHVOUnApproveBP();
                LettercreditBillVO[] retvos = bp.unApprove(clientFullVOs, originBills);
                return retvos;
        }

}